<?php // Register and load the widget
	function good_news_lite_category_post_load_widget() {
		register_widget('good_news_lite_category_post_widget');
	}
	add_action('widgets_init', 'good_news_lite_category_post_load_widget');
 
	// Creating the widget 
class good_news_lite_category_post_widget extends WP_Widget {	
	function __construct(){
		$widget_ops = array('classname' => 'good-news-lite-category-post-widget', 'description' => esc_html__( "The Widget Can Display Posts Form Selected Category", 'good-news-lite') );
        parent::__construct('good-category-post-widget_1', esc_html__('GN : Top and bottom post widget', 'good-news-lite'), $widget_ops);
		
		$this->alt_option_name = 'good_news_lite_category_flush_widget_template1';
        add_action( 'save_post', array($this, 'good_news_lite_category_flush_widget_cache_template') );
        add_action( 'deleted_post', array($this, 'good_news_lite_category_flush_widget_cache_template') );
        add_action( 'switch_theme', array($this, 'good_news_lite_category_flush_widget_cache_template') );
    }

	// Creating widget front-end
	public function widget( $args, $instance ) {

		$good_news_lite_category_cache = wp_cache_get('good_news_lite_category_post_widget', 'widget');
        if ( !is_array($good_news_lite_category_cache) )
            $good_news_lite_category_cache = array();

        if ( ! isset( $args['widget_id'] ) )
            $args['widget_id'] = $this->id;

        if ( isset( $good_news_lite_category_cache[ $args['widget_id'] ] ) ) {
            echo esc_attr($good_news_lite_category_cache[ $args['widget_id'] ]);
            return;
        }
         ob_start();
        extract($args);
		$title =(isset($instance['title']))? apply_filters( 'widget_title', $instance['title'] ):__('Title Category','good-news-lite');
		$num = !empty($instance['num']) ? $instance['num'] :'-1';
 		$category = !empty($instance['category']) ? $instance['category'] : '';
 		$arg = 	array('post_type'=>'post', 'posts_per_page'=>$num );
 		($category>0)?$arg['category__in']=$category:'';
 		$good_news_lite_category_posts = new WP_Query($arg);
 		?>
 		   <div class="latest-post top-and-bottom-post-widget">		     
		         <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
		            <div class="post_title">
		               <h4><?php echo esc_html($title); ?></h4>
		            </div>
		            <?php $counter=1; if($good_news_lite_category_posts->have_posts()):
		            	while($good_news_lite_category_posts->have_posts()): $counter = ($counter>4)?1:$counter; $good_news_lite_category_posts->the_post();
		            ?>
		            <div class="grid-post">		               
		               <?php if($counter==1){ ?>
		                  <div class="col-4">
		                    <?php if ( has_post_thumbnail() ) : ?>
			                    <a href="<?php the_permalink(); ?>"><?php the_post_thumbnail('good_news_lite_thumbnail_image',array( 'alt' => the_title_attribute(array('echo' => false,)), 'class' => 'img-responsive') ); ?></a>
			                <?php else: ?>
			                    <a href="<?php the_permalink(); ?>">
			                    	<div class="no-post-thumbnail"><i class="fa fa-image"></i> </div>
			                    </a>
			                <?php endif; ?>
		                  </div>
		                  <div class="text">
		                     <h2 class="t-small"><a href="<?php the_permalink();?>" title=""><?php the_title();?></a></h2>
		                     <div class="meta-loop">
		                        <div class="pull-left">
		                           <span class="author"><i class="fa fa-user" aria-hidden="true"></i> <a href="<?php the_permalink();?>" title="" rel="author"><?php the_author();?></a></span>&nbsp;    
		                           <span class="date"><i class="fa fa-calendar-o" aria-hidden="true"></i> <?php echo esc_html(get_the_date('d M Y')); ?></span> 
		                        </div>		                        
		                        <div class="clearfix"></div>
		                     </div>
		                     <div class="meta-loop">
		                        <p><?php the_excerpt();?></p>
		                     </div>
		                  </div>

		                <?php } else { ?>
		                     <div class="text">
			                     <div class="row">
			                        <div class="col-md-12">
			                           <div class="post_bottom_contain">
			                              <div class="post_bottom_img">
			                                <?php if ( has_post_thumbnail() ) : ?>
							                    <a href="<?php the_permalink(); ?>"><?php the_post_thumbnail('good_news_lite_ThumbnailSmallImage',array( 'alt' => the_title_attribute(array('echo' => false,)), 'class' => '') ); ?></a>
							                <?php else: ?>
							                    <a href="<?php the_permalink(); ?>">
							                    	<div class="no-post-thumbnail"><i class="fa fa-image"></i> </div>
							                    </a>
							                <?php endif; ?>
			                              </div>
			                              <div class="post_bottom_img_contain">
			                                 <a href="<?php the_permalink();?>"><?php the_title();?></a>
			                                 <div class="meta-loop">
			                                    <div class="pull-left time">
			                                       <span class="author"><i class="fa fa-user" aria-hidden="true"></i> <a href="<?php the_permalink();?>" title="" rel="author"><?php the_author();?></a></span>&nbsp;
			                                       <span class="date"><i class="fa fa-calendar-o" aria-hidden="true"></i> <?php echo esc_html(get_the_date('d M Y'));?></span> 
			                                    </div>			                                    
			                                    <div class="clearfix"></div>
			                                 </div>
			                              </div>
			                              <div class="clearfix"></div>
			                           </div>
			                        </div>
			                     </div>
		                     </div>
		                <?php } $counter++;?>	                  
		              </div>
		            <?php endwhile; wp_reset_postdata(); endif; ?>		         
		      </div>
		   </div>		

	<?php $good_news_lite_category_cache[$args['widget_id']] = ob_get_flush();
        wp_cache_set('good_news_lite_category_flush_widget_cache_template2', $good_news_lite_category_cache, 'widget');
    }
         
	// Widget Backend 
	public function form( $instance ) {
		
		$category = isset($instance['category'])?$instance['category']:'';	
		$title = (isset($instance['title'])) ? $instance['title'] : __('News title','good-news-lite');
		$num    = isset( $instance['num'] ) ?  $instance['num']  : 3; ?>
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_html_e('Title:','good-news-lite'); ?></label> 
			<input class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" type="text" value="<?php echo esc_attr($title); ?>" />
		</p>
		<p>
			<label for="<?php echo esc_attr($this->get_field_id( 'num' )); ?>"><?php esc_html_e('Number Of Posts To Show','good-news-lite'); ?></label>
			<input type="number" class="widefat select-numpost" id="<?php echo esc_attr($this->get_field_id('num')); ?>" name="<?php echo esc_attr($this->get_field_name('num')); ?>" value="<?php echo esc_attr($num);?>" />
		</p>
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('category'));?>"><?php esc_html_e('Select Post Category','good-news-lite'); ?></label>
			<?php wp_dropdown_categories(array('show_option_none'=>'-Select-','name'=> $this->get_field_name('category'), 'selected'=> $category)); ?>
		</p>
	<?php 
	}     
	
	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = ! empty( $new_instance['title'] ) ? sanitize_text_field( $new_instance['title'] ) : '';
        $instance['num'] = ! empty( $new_instance['num'] ) ? absint( $new_instance['num'] ) : 3;
		$instance['category'] = ( !empty( $new_instance['category']) && $new_instance['category'] > 0 ) ? absint($new_instance['category']):'';

        $this->good_news_lite_category_flush_widget_cache_template();
        $alloptions = wp_cache_get( 'alloptions', 'options' );
        if ( isset($alloptions['good_news_lite_category_flush_widget_cache_template2']) )
            delete_option('good_news_lite_category_flush_widget_cache_template2');
        return $instance;
	}
	function good_news_lite_category_flush_widget_cache_template() {
        wp_cache_delete('good_news_lite_category_flush_widget_cache_template2', 'widget');
    }
} 